﻿using System;
using UnityEngine;
using System.Text;

using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MacGruber;


namespace SPQR
{
    public class SPQRDynamicNumbers : MVRScript {

        private EventTrigger myEventTrigger;

        protected JSONStorableString varValue;
        protected JSONStorableString varMin;
        protected JSONStorableString varMax;
        protected JSONStorableString varDefault;
        
        JSONStorableStringChooser jchooser;
        int titles = 0;
    
        public override void Init()
        {
            if(containingAtom.type != "UIText") return;
            Utils.OnInitUI(CreateUIElement);


            CreateTitle("DYNAMIC Numbers",50,false);
            CreateTitle("AETERNUM TOOLS",30,true);
            
            


            JSONStorableString jstring = new JSONStorableString("instructions2", "\n This plugin is meant to be called from triggers. Here you can just set min, max and default values for your field. It updates the numerical value held by this text atom.");
            UIDynamicTextField dtext = CreateTextField(jstring, true);
            dtext.UItext.supportRichText = true;
            dtext.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext.height = 350f;

            JSONStorableString jstring2 = new JSONStorableString("instructions1", "\n 1. set a value in the Value field \n 2. set an operation to be done with that value to the current value of the text atom. \n\n OperationResetDefault, Operation++ & Operation-- don't need a Value to be set, you can call just the Operation.");
            UIDynamicTextField dtext2 = CreateTextField(jstring2);
            dtext2.UItext.supportRichText = true;
            dtext2.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext2.height = 350f;
            

            Utils.SetupSpacer(this, 70, false);
            Utils.SetupSpacer(this, 70, true);


            myEventTrigger = new EventTrigger(this, "TriggerOnUpdate");
            Utils.SetupButton(this, "Trigger On Update", myEventTrigger.OpenPanel, false);

            Utils.SetupButton(this, "Test Trigger", TestTrigger, true);
            //Utils.SetupAction(this, "TriggerOnUpdate", Trigger);
            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
            SimpleTriggerHandler.LoadAssets();


            Utils.SetupSpacer(this, 50, false);
            Utils.SetupSpacer(this, 50, true);


            

            varValue = new JSONStorableString("Value", "", UpdateVarValue);
            RegisterString(varValue);
            UIDynamicLabelInput myStringInput = Utils.SetupTextInput(this, "New value", varValue, false);

            varMin = new JSONStorableString("ValueMin", "", UpdateVarMin);
            RegisterString(varMin);
            UIDynamicLabelInput myStringInput2 = Utils.SetupTextInput(this, "Min value", varMin, false);


            varMax = new JSONStorableString("ValueMinMax", "", UpdateVarMax);
            RegisterString(varMax);
            UIDynamicLabelInput myStringInput3 = Utils.SetupTextInput(this, "Max value", varMax, false);

            varDefault = new JSONStorableString("ValueDefault", "", UpdateVarDefault);
            RegisterString(varDefault);
            UIDynamicLabelInput myStringInput4 = Utils.SetupTextInput(this, "Default value", varDefault, false);

    
            List<string> choices = new List<string>();
            choices.Add("None");
            choices.Add("OperationResetDefault");
            choices.Add("OperationSetValue");
            choices.Add("OperationAddValue");
            choices.Add("OperationSubstractValue");
            choices.Add("Operation++");
            choices.Add("Operation--");
            jchooser = new JSONStorableStringChooser("OperationType", choices, "None", "Operation", OperationUpdate);
            RegisterStringChooser(jchooser);
            UIDynamicPopup udp = CreatePopup(jchooser, true);
            //CreateScrollablePopup(jchooser, true);
            udp.labelWidth = 300f;



            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
            UIUpdate();
        }
        private void OnAtomRename(string oldid, string newid)
        {
            myEventTrigger.SyncAtomNames();
        }
        private void UIUpdate()
        {
        }


        void Start()
        {
            try
            {
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void Update()
        {
            try
            {
            //    myEventTrigger.Update();
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private void TestTrigger()
        {
           Trigger();

        }
        private void Trigger()
        {
            myEventTrigger.Trigger();
        }

        void FixedUpdate()
        {
            try
            {
                // put code in here
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnDestroy()
        {
            SuperController.singleton.onAtomUIDRenameHandlers -= OnAtomRename;
            myEventTrigger.Remove();
            Utils.OnDestroyUI();
        }



        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
            if (includePhysical || forceStore)
            {
                needsStore = true;
                jc[myEventTrigger.Name] = myEventTrigger.GetJSON(base.subScenePrefix);
            }
            return jc;
        }

        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);

            if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
            {
                myEventTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
            }
        }



        //////////////////////////////////////////////

        void UpdateVarValue(string name)
        {
            

        }
         void UpdateVarMin(string name)
        {
            

        }
         void UpdateVarMax(string name)
        {
            

        }
          void UpdateVarDefault(string name)
        {
            

        }

        
		protected void OperationUpdate(string s) {
            int currentValue = GetText();
            int newValue = ToInt(varValue.val);
            int updatedvalue = currentValue;
            if(jchooser.val == "None") return;
            switch(jchooser.val){
                case "OperationResetDefault":
                    updatedvalue = ToInt(varDefault.val);
                    break;
                case "OperationSetValue":
                    updatedvalue = newValue;
                    break;
                case "OperationAddValue":
                    updatedvalue = currentValue + newValue;
                    break;
                case "OperationSubstractValue":
                    updatedvalue = currentValue - newValue;
                    break;
                case "Operation++":
                    updatedvalue = currentValue+1;
                    break;
                case "Operation--":
                    updatedvalue = currentValue-1;
                    break;

            }

            if(varMin.val != ""){
                if(updatedvalue < ToInt(varMin.val)){
                    updatedvalue = ToInt(varMin.val);
                }
                if(updatedvalue > ToInt(varMax.val)){
                    updatedvalue = ToInt(varMax.val);
                }
            }

            SetAtomText(updatedvalue.ToString());

            jchooser.val = "None";

            Trigger();

		}

        public static int ToInt(string s){
            if(s=="" || s== null) s = "0";
            return Int32.Parse(s);
        }


        public int GetText()
        {
            JSONStorable f = containingAtom.GetStorableByID("Text");
            JSONStorableString fs = f.GetStringJSONParam("text");
            return ToInt(fs.val);
        }

        void SetAtomText(string t){ 
            JSONStorable f = containingAtom.GetStorableByID("Text");
            JSONStorableString fs = f.GetStringJSONParam("text");
            fs.val = t;
         }


        private void CreateTitle(string text, int fontsize, bool right,int spacing){
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right){
                JSONStorableString title1 = new JSONStorableString("title"+(++titles), "\n<size="+fontsize+"><b>"+text+"</b></size>");
                UIDynamicTextField title1text = CreateTextField(title1, right);
                title1text.UItext.supportRichText = true;
                title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
                title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                title1text.height = 100f;
                title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

	}
}